#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <winreg.h>

#include <mpplugin.h>
#include "plgclone.h"

//REGKEY_PLGDATA is usually the same name of module file name.
//Please define REGKEY_PLUGDATA before using this sample.
#define REGKEY_PLGDATA "PLGSAMPL3"


BOOL DWPC_GetCloneIDFromCommand(LPCSTR lpszCommand, LPSTR lpszPlgCmd, int* pnID)
{
    int len= strlen(lpszCommand);
    /* check if lpszCommand matches %s-%02d */
    if (len<4)
        return FALSE;
    if (lpszCommand[len-3]!='-')
        return FALSE;
    if (!(('0'<= lpszCommand[len-2] && lpszCommand[len-2] <= '9') &&
          ('0'<= lpszCommand[len-1] && lpszCommand[len-1] <= '9') ))
        return FALSE;

    strcpy(lpszPlgCmd,lpszCommand);
    lpszPlgCmd[len-3]=0;
    *pnID= (lpszCommand[len-2]-'0')*10+lpszCommand[len-1]-'0';
    return TRUE;
}

BOOL DWPC_CreateInstanceString(LPCSTR lpszBody, int nID, LPSTR lpszPlgStr)
{
    sprintf(lpszPlgStr,"%s-%02d",lpszBody,nID);
    return TRUE;
}

BOOL DWPC_FindRegistryKey(LPCSTR lpszPlgStr)
{
	HKEY subKey;
	LONG result;
	DWORD type;
	DWORD cbData=0;
	
	result = RegOpenKeyEx(HKEY_CURRENT_USER,
				PLUGGEDIN_REGKEY"\\"REGKEY_PLGDATA,
				0, KEY_READ, &subKey);
	if (result != ERROR_SUCCESS){
		return FALSE;
	}
	
	result = RegQueryValueEx(subKey, lpszPlgStr, NULL, &type, NULL, &cbData);
	RegCloseKey(subKey);   
	return (result==ERROR_SUCCESS);

}

BOOL DWPC_AllocateRegistryKey(LPCSTR lpszPlgStr)
{
    HKEY subKey;
	LONG result;
	DWORD disposition;
	char c=0;	
	result = RegCreateKeyEx(HKEY_CURRENT_USER,
				   PLUGGEDIN_REGKEY"\\"REGKEY_PLGDATA,
					0, REG_NONE, REG_OPTION_NON_VOLATILE,
					KEY_WRITE|KEY_READ,NULL, &subKey, &disposition);

	if (result!=ERROR_SUCCESS){
	    return FALSE;
	}

	result = RegSetValueEx(subKey, lpszPlgStr, 0, REG_BINARY, &c,1);

	RegCloseKey(subKey);
    return (result==ERROR_SUCCESS);
}

BOOL DWPC_ReleaseRegistryKey(LPCSTR lpszPlgStr)
{
	HKEY subKey;
	LONG result;

	result = RegOpenKeyEx(HKEY_CURRENT_USER,
				PLUGGEDIN_REGKEY"\\"REGKEY_PLGDATA,
				0, KEY_SET_VALUE, &subKey);
	if (result != ERROR_SUCCESS){
		return FALSE;
	}
	
	result = RegDeleteValue(subKey, lpszPlgStr);

	RegCloseKey(subKey);
	return (result==ERROR_SUCCESS);
}

int  DWPC_GetRegistryData(LPCSTR lpszPlgStr, char* pData, int nSize)
{
	HKEY subKey;
	LONG result;
	DWORD type;
	DWORD cbData=0;
	DWORD cbData2=0;
	
	result = RegOpenKeyEx(HKEY_CURRENT_USER,
				PLUGGEDIN_REGKEY"\\"REGKEY_PLGDATA,
				0, KEY_READ, &subKey);
	if (result != ERROR_SUCCESS){
		result = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
					PLUGGEDIN_REGKEY"\\"REGKEY_PLGDATA,
					0, KEY_READ, &subKey);
		if (result != ERROR_SUCCESS)
			return -1;
	}
	
	result = RegQueryValueEx(subKey, lpszPlgStr, NULL, &type, NULL, &cbData);
	if (cbData<(DWORD)nSize)
	    nSize=cbData;
	
    if (pData!=NULL && nSize>1){
        cbData2=nSize;
    	result = RegQueryValueEx(
        			subKey, lpszPlgStr, NULL, &type, (BYTE *)pData, &cbData2);
    }

	RegCloseKey(subKey);

    if (result != ERROR_SUCCESS)
        nSize=-1;
    else
        nSize=cbData;

	return	nSize;
}

BOOL DWPC_SetRegistryData(LPCSTR lpszPlgStr, const char* pData, int nSize)
{

    HKEY subKey;
	LONG result;
	
	result = RegOpenKeyEx(HKEY_CURRENT_USER,
				PLUGGEDIN_REGKEY"\\"REGKEY_PLGDATA,
				0, KEY_READ|KEY_WRITE, &subKey);

	if (result!=ERROR_SUCCESS)
	    return FALSE;
	
	result = RegSetValueEx(subKey, lpszPlgStr, 0, REG_BINARY, (BYTE *)pData, nSize);
	
	RegCloseKey(subKey);
    
	return (result==ERROR_SUCCESS);
    
}


